<?php 
/* 
 * 	   Copyright 2010 WALTHER Jrmy & MOLE Bruno
 *    Zoku Server
 *    Version 1.0-beta
 *    
 *    Contact the authors :
 *    WALTHER Jrmy	: jeremy.walther@ftad.fr
 *    MOLE Bruno		: bruno.mole@ftad.fr
 *    
 *    This file is part of Zoku Server.
 *
 *    Zoku Server is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Zoku Server is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Zoku Server.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
?>
<?php 

class ZS_KeyStoric extends ZS_Base
{
	public $id;
	public $key;
	public $card_id;
	public $create_date;
	
	function __construct($row = "")
	{
		parent::__construct();
		if ($row != "")
		{
			$this->createFromArray($row);
		}
	}
	
	public function createFromArray($array)
	{
		if (isset($array['id']))			{ $this->id = $array['id']; };
		if (isset($array['key']))			{ $this->key = $array['key']; };
		if (isset($array['card_id']))		{ $this->card_id = $array['card_id']; };
		if (isset($array['create_date']))	{ $this->create_date = $array['create_date']; };
		return true;
	}
	
	public function selectById($id)
	{
		if ($result = $this->getDBLink()->query("SELECT * FROM `".$this->getDBPrefix()."_keystoric` WHERE `id` = '$id'"))
		{
			if($row = $this->getDBLink()->fetch($result))
			{
				return $this->createFromArray($row);
			}
		}
		return false;
	}
	
	public function selectByKey($key)
	{
		if ($result = $this->getDBLink()->query("SELECT * FROM `".$this->getDBPrefix()."_keystoric` WHERE `key` = '$key'"))
		{
			if($row = $this->getDBLink()->fetch($result))
			{
				return $this->createFromArray($row);
			}
		}
		return false;
	}
	
	public function getVars()
	{
		return get_object_vars($this);
	}
	
	public function createInDB()
	{
		if ($this->ifNotExists($this->key))
		{
			if ($result = $this->getDBLink()->query("INSERT INTO `".$this->getDBPrefix()."_keystoric` 
			(`key`, `card_id`, `create_date`) 
			VALUES 
			('$this->key', '$this->card_id', '".time()."')"))
			{
				$this->id = $this->getDBLink()->lastId();
			}
			return $result;
		}
		return false;
	}
	
	public function getLastSince($date)
	{
		if ($result = $this->getDBLink()->query("SELECT * FROM `".$this->getDBPrefix()."_keystoric` WHERE `create_date` >= '$date' ORDER BY `create_date` DESC"))
		{
			$array = array();
			while ($row = $this->getDBLink()->fetch($result))
			{
				$keystoric = new ZS_KeyStoric($row);
				$array[] = $keystoric->getPublicVars();
			}
			return $array;
		}
		return false;
	}
	
	public function getPublicVars()
	{
		return array(	"id"			=>	$this->id,
						"key"			=>	$this->key,
						"card_id"		=>	$this->card_id,
						"create_date"	=>	$this->create_date);
	}
	
	public function delete()
	{
		return $this->getDBLink()->query("DELETE FROM `".$this->getDBPrefix()."_keystoric` WHERE `id` = '$this->id'");
	}
	
	public function ifNotExists($key)
	{
		if ($result = $this->getDBLink()->query("SELECT COUNT(`id`) FROM `".$this->getDBPrefix()."_keystoric` WHERE `key` = '$key'"))
		{
			if ($this->getDBLink()->result($result) == 0)
			{
				return true;
			}
		}
		return false;
	}
}

?>